#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t, n;
    cin>>t;

    for(int m=0; m<t; m++){
        cin>>n;
        int a, b, c, arr[n][3], path=0;
        for(int i=0; i<n; i++){
            cin>>a>>b>>c;
            arr[i][0]=a;
            arr[i][1]=b;
            arr[i][2]=c;
        };
        int bank, bmax;
        for(int i=0; i<n; i++){
            int f=0, check1, check2, check3, s=0, fixed1, fixed2;
            for(int j=i+1; j<n; j++){
                if(f==0){
                    f++;
                    s+=arr[i][2]+arr[j][2];
                    if(arr[j][0]==arr[i][0]) {
                        check1=arr[i][0];
                        check2=arr[i][1];
                        check3=arr[j][1];
                    }else if(arr[j][1]==arr[i][0]) {
                        check1=arr[i][0];
                        check2=arr[i][1];
                        check3=arr[j][0];
                    }else if(arr[j][0]==arr[i][1]) {
                        check1=arr[i][1];
                        check2=arr[i][0];
                        check3=arr[j][1];
                    }else if(arr[j][1]==arr[i][1]) {
                        check1=arr[i][1];
                        check2=arr[i][0];
                        check3=arr[j][0];
                    }else {
                        f--;
                        s-=arr[j][2]+arr[i][2];
                    }
                    fixed1=s;
                }else{
                    if((arr[j][0]==check1)||arr[j][1]==check1) {
                        f++;
                        s+=arr[j][2];
                    }else if(((arr[j][0]==check2)&&(arr[j][1]==check3))||((arr[j][1]==check2)&&(arr[j][0]==check3))) {
                        if(fixed2<arr[j][2]){
                            fixed2=arr[j][2];
                        };
                    };
                };
            };
            if((arr[i][2]+s)<(fixed1+fixed2)) bank = fixed1+fixed2;
            else bank = arr[i][2]+s;
            if(bmax<b) bmax=bank;
        };
        cout<<bmax<<"\n";
    };
}
